/*HEADER*******************************************************************
***************************************************************************
***
*** Copyright (c) 2000-2006 Vision Components
***
*** All rights reserved
***
*** This software embodies materials and concepts which are confidential
*** to Vision Components
***
*** File: vcrt_compat.h
***                                                            
*** Comments: 
***		main VCRT header file - deprecated functions
***
***
*** Revision History:
***    Date          Version    Author  Changes
***    Jan 18, 2006  5.00       MS      Initial Version for VCRT V5.00
***    Dec 22, 2006  5.25.4		MS		moved sbfull,rbempty,set_lut_comp
***    Jul 01, 2008  5.27.9		MS		disabled header struct/class
***
***************************************************************************
*END***********************************************************************/
#ifndef _VCRT_COMPAT_h
#define _VCRT_COMPAT_h


//void sysprtfree(int type); /* deprecated NOT useable anymore !!! */
#define sysprtfree(type) printf("%d",sysmemfree())

int sbfull(void); 
int rbempty(void);
void set_lut_comp(int r, int g, int b); 

typedef long ADDRESS;

/*
int jump(int,int p1,int p2,int p3,int p4,int p5,int p6,int p7,
int p8,int p9,int p10,int p11,int p12,int p13,int p14);
*/

void blrdw(int, int *, long);
void blwrw(int, int *, long);
void blrdb(int, int *, long);
void blwrb(int, int *, long);

/* flash EPROM functions                                */

int erase(int sector);
int erase_multi(int start_sector,int count);

int erasez(int);
long  flpgm8x (char  val, char  *addr);
int  flpgm16x(short val, short *addr);
int  flpgm16z(short val, short *addr);
int  flpgm32x(int   val, int   *addr);

/* compatibility mode                                   */

int flpgm8(int x, long adr);
#define flpgm(a,b)      flpgm8(b,a)

/*
#define flpgm(a,b)      flpgm8x ((char)(b),(char *)(FLASH_BASE+(a)))
#define flpgm8(a,b)     flpgm8x ((char)(a),(char *)(FLASH_BASE+(b)))

#define flpgm16(a,b)    flpgm16x((short)(a),(short *)(FLASH_BASE+(b)))
#define flpgm32(a,b)    flpgm32x((int)(a),(int *)(FLASH_BASE+(b)))
*/

#ifdef VCRT_USE_OLD_GETF8 // VCRT_VERSION < VCRT5.23.1

#ifndef SBC4000
  #define getf8(x)   (int) *((unsigned char *) (FLASH_BASE + (x)))
#else
  int getf8(int x);

  int getf8(int x)
  {
	 *((volatile int *)(FA40_FLASH)) = (int)x>>20;	/* secondary address	*/
	 return	(int) *((unsigned char *) (FLASH_BASE + (x&(1<<20)-1)));
  }
#endif

#else

int getf8(int x); // since VCRT5.23.1 a kernel function !!!

#endif   
 

#define getf16(x)  (int)  ((getf8(x)<<8) + getf8((x)+1))
#define getf32(x)  (long) ((getf16(x)<<16) + getf16((x)+2))
 
/*
#define getf32(x)  (long) (getf8(x)<<24 + getf8((x)+1)<<16       \
                            + getf8((x)+2)<<8 + getf8((x)+3))
*/

long search(int, char *);
long snext(void);
long fnaddr(long);
int fname(long,char *);
void htwait(int);

long last(int *type, char *name);           /* find last file ????        */
int del(int type, char *name);              /* delete file                */

long fremain(void);
void fcreat(long fp, char *name, int type);
void flclose(long fp, long length);

/* DRAM malloc functions                */

int  DRAMPagesAvail();
long DRAMBytesAvail();
long DRAMWordsAvail();

int DRAMPgMalloc(unsigned int Count);

int  DRAMPageMalloc(unsigned long BytesWanted);
long DRAMByteMalloc(unsigned long BytesWanted);
long DRAMWordMalloc(unsigned long WordsWanted);

void DRAMPgFree(int page);
void DRAMByteFree(long StartByte);
void DRAMWordFree(long StartWord);

int DRAMScreenMalloc(void);
int DRAMOvlMalloc(void);

/* wrong  */
#define rd20(x)     (int)*((short *)((x)<<1))
#define wr20(y,x)   *((short *)((x)<<1)) = (short)(y)
#define rd32(x)     (long)*((int *)((x)<<1))
#define wr32(y,x)   *((int *)((x)<<1)) = (int)(y)
/*
int  rd20(long x);
void wr20(int v, long x);
long rd32(long x);
void wr32(long v, long x);
*/

#define rpix(x)     (int)*((unsigned char *)(x))
//#define wpix(y,x)   *((char *)(x)) = (char)(y)	/* function now defined in contour.c	*/
//#define xorpix(y,x) *((char *)(x)) ^= (char)(y)	/* function now defined in contour.c	*/

#define rovl(x)     (int)*((char *)(x))
#define wovl(y,x)   *((char *)(x)) = (char)(y)
#define blrdo(a,b,c)    blrdb(a,b,c)
#define blwro(a,b,c)    blwrb(a,b,c)
#define xorovl(y,x) *((char *)(x)) ^= (char)(y)

/*
#define outPLC(x) {                                            \
                    int y=(getvar(reg3) & 0xf0) | (x & 0x0f);  \
                    setvar(reg3,y);                            \
                    swrite8(3,y);                              \
                  }
*/
#define setFRAME() setreg1(0x04)
#define setFIELD() resreg1(0x04)

/* image must be defined
void chprint(char *str, image *a, int cx, int cy);
void chprint_ov(char *str, image *a, int cx, int cy);
*/
#define chprint_ov(a,b,c,d)     chprint1(a,b,c,d,1)

#define wo_list(count, ad_list, v_list)    wp_list(count, ad_list, v_list)
#define wo_set(count, ad_list, value)      wp_set(count, ad_list, value)
#define wo_xor(count, ad_list, value)      wp_xor(count, ad_list, value)
#define ro_list(count, ad_list, v_list)    rp_list(count, ad_list, v_list)

/*
void vcsetup(void);
void *vcmalloc(unsigned int size);
*/

/* the following should only be enabled if needed */
#if 0 
#ifndef __embedded_cplusplus
typedef struct
  {
  struct header *ptr;   /* list pointer         */
  unsigned size;        /* size of free segment */
  } header;
#else
class header
  {
  struct header *ptr;   /* list pointer         */
  unsigned size;        /* size of free segment */
  };
#endif // __embedded_cplusplus
#endif

#endif
/* EOF */

